﻿namespace TabsStudioMarker
{
    class FileUtils
    {
        private const int MAX_PATH = 260;

        public static string GetRelativePath(string baseDirectory, string absoluePath)
        {
            if (baseDirectory == null || absoluePath == null)
                return null;
            if (baseDirectory.Length > MAX_PATH || absoluePath.Length > MAX_PATH)
                return null;

            System.Text.StringBuilder str = new System.Text.StringBuilder(MAX_PATH);
            bool ret = NativeMethods.PathRelativePathTo(str,
                baseDirectory, System.IO.FileAttributes.Directory,
                absoluePath, System.IO.FileAttributes.Normal);
            if (!ret)
                return null;

            string result = str.ToString();
            if (result.StartsWith(@".\"))
                result = result.Substring(2);

            return result;
        }

        public static string GetLocalPath(string baseDirectory, string absoluePath)
        {
            string result = GetRelativePath(baseDirectory, absoluePath);
            if (result == null || result.StartsWith(".."))
                return null;

            return result;
        }
    }

    internal static class NativeMethods
    {
        [System.Runtime.InteropServices.DllImport("shlwapi.dll", CharSet = System.Runtime.InteropServices.CharSet.Unicode)]
        static public extern bool PathRelativePathTo(
             [System.Runtime.InteropServices.Out] System.Text.StringBuilder pszPath,
             [System.Runtime.InteropServices.In] string pszFrom,
             [System.Runtime.InteropServices.In] System.IO.FileAttributes dwAttrFrom,
             [System.Runtime.InteropServices.In] string pszTo,
             [System.Runtime.InteropServices.In] System.IO.FileAttributes dwAttrTo
        );
    }
}
