﻿namespace TabsStudioMarker
{
    class OpenDocuments
    {
        class TabDocuments
        {
            public TabDocuments()
            {
                extensions = new System.Collections.Generic.List<WindowDocument>();
            }

            public System.Windows.Controls.TabItem tab;
            public System.Collections.Generic.List<WindowDocument> extensions;
        }

        public OpenDocuments()
        {
            openTabs = new System.Collections.Generic.List<TabDocuments>();
        }

        public System.Collections.Generic.List<WindowDocument> FindDocuments(System.Windows.Controls.TabItem tab)
        {
            foreach (TabDocuments openTab in openTabs)
            {
                if (openTab.tab == tab)
                    return openTab.extensions;
            }
            return new System.Collections.Generic.List<WindowDocument>();
        }

        public WindowDocument FindDocument(EnvDTE.Window w)
        {
            foreach (TabDocuments openTab in openTabs)
            {
                foreach (WindowDocument wd in openTab.extensions)
                {
                    if (wd.window == w)
                        return wd;
                }
            }
            return null;
        }

        public void OnTabExtensionCreated(TabsStudioExt.TabExtensionEventArgs e)
        {
            foreach (TabDocuments tab in openTabs)
            {
                if (tab.tab == e.Tab.TabItem)
                {
                    tab.extensions.Add(new WindowDocument(e.TabExtension.Window));
                    return;
                }
            }

            TabDocuments newTab = new TabDocuments();
            newTab.tab = e.Tab.TabItem;
            newTab.extensions.Add(new WindowDocument(e.TabExtension.Window));
            openTabs.Add(newTab);
        }

        public void OnTabExtensionDestroyed(TabsStudioExt.TabExtensionEventArgs e)
        {
            foreach (TabDocuments tab in openTabs)
            {
                if (tab.tab == e.Tab.TabItem)
                {
                    foreach (WindowDocument ext in tab.extensions)
                    {
                        if (ext.window == e.TabExtension.Window)
                        {
                            tab.extensions.Remove(ext);
                            break;
                        }
                    }
                    if (tab.extensions.Count == 0)
                        openTabs.Remove(tab);
                    return;
                }
            }
        }

        public void OnTabExtensionRenamed(TabsStudioExt.TabExtensionEventArgs e)
        {
            foreach (TabDocuments tab in openTabs)
            {
                if (tab.tab == e.Tab.TabItem)
                {
                    foreach (WindowDocument ext in tab.extensions)
                    {
                        if (ext.window == e.TabExtension.Window)
                        {
                            ext.UpdateDocument();
                            break;
                        }
                    }
                    return;
                }
            }
        }

        private System.Collections.Generic.List<TabDocuments> openTabs;
    }
}
