﻿namespace TabsStudioMarker
{
    using HighlightedTabList = System.Collections.Generic.List<TabHighlightState>;

    class SolutionStateSaver
    {
        public SolutionStateSaver(EnvDTE80.DTE2 dte_, Model model_)
        {
            model = model_;
            dte = dte_;
            storage = new TabsStudioExt.Util.SolutionStorage<HighlightedTabList>(dte, "marker.tss", ".marker");
        }

        public void Save()
        {
            HighlightedTabList tabList = model.GetTabs();
            try
            {
                storage.Save(tabList);
            }
            catch (System.Exception)
            {
            }
        }

        public void Load()
        {
            HighlightedTabList tabList = null;
            try
            {
                tabList = storage.Load();
            }
            catch (System.Exception)
            {
            }

            if (tabList != null)
                model.SetTabs(tabList);
        }

        private Model model;
        private EnvDTE80.DTE2 dte;
        private TabsStudioExt.Util.SolutionStorage<HighlightedTabList> storage;
    }
}
